/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.customsearch.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Context.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the CustomSearch API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Context extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.util.List<Facets>> facets;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String title;

  /**

   * The value returned may be {@code null}.
   */
  public java.util.List<java.util.List<Facets>> getFacets() {
    return facets;
  }

  /**

   * The value set may be {@code null}.
   */
  public Context setFacets(java.util.List<java.util.List<Facets>> facets) {
    this.facets = facets;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getTitle() {
    return title;
  }

  /**

   * The value set may be {@code null}.
   */
  public Context setTitle(String title) {
    this.title = title;
    return this;
  }

  /**
   * Model definition for ContextFacets.
   */
  public static final class Facets extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String anchor;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String label;

    /**

     * The value returned may be {@code null}.
     */
    public String getAnchor() {
      return anchor;
    }

    /**

     * The value set may be {@code null}.
     */
    public Facets setAnchor(String anchor) {
      this.anchor = anchor;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getLabel() {
      return label;
    }

    /**

     * The value set may be {@code null}.
     */
    public Facets setLabel(String label) {
      this.label = label;
      return this;
    }

  }

}
