/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.customsearch.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Promotion.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the CustomSearch API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Promotion extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<BodyLines> bodyLines;

  static {
    // hack to force ProGuard to consider BodyLines used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(BodyLines.class);
  }

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String displayLink;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String htmlTitle;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Image image;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String link;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String title;

  /**

   * The value returned may be {@code null}.
   */
  public java.util.List<BodyLines> getBodyLines() {
    return bodyLines;
  }

  /**

   * The value set may be {@code null}.
   */
  public Promotion setBodyLines(java.util.List<BodyLines> bodyLines) {
    this.bodyLines = bodyLines;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getDisplayLink() {
    return displayLink;
  }

  /**

   * The value set may be {@code null}.
   */
  public Promotion setDisplayLink(String displayLink) {
    this.displayLink = displayLink;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getHtmlTitle() {
    return htmlTitle;
  }

  /**

   * The value set may be {@code null}.
   */
  public Promotion setHtmlTitle(String htmlTitle) {
    this.htmlTitle = htmlTitle;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Image getImage() {
    return image;
  }

  /**

   * The value set may be {@code null}.
   */
  public Promotion setImage(Image image) {
    this.image = image;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getLink() {
    return link;
  }

  /**

   * The value set may be {@code null}.
   */
  public Promotion setLink(String link) {
    this.link = link;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getTitle() {
    return title;
  }

  /**

   * The value set may be {@code null}.
   */
  public Promotion setTitle(String title) {
    this.title = title;
    return this;
  }

  /**
   * Model definition for PromotionBodyLines.
   */
  public static final class BodyLines extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String htmlTitle;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String link;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String title;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String url;

    /**

     * The value returned may be {@code null}.
     */
    public String getHtmlTitle() {
      return htmlTitle;
    }

    /**

     * The value set may be {@code null}.
     */
    public BodyLines setHtmlTitle(String htmlTitle) {
      this.htmlTitle = htmlTitle;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getLink() {
      return link;
    }

    /**

     * The value set may be {@code null}.
     */
    public BodyLines setLink(String link) {
      this.link = link;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getTitle() {
      return title;
    }

    /**

     * The value set may be {@code null}.
     */
    public BodyLines setTitle(String title) {
      this.title = title;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getUrl() {
      return url;
    }

    /**

     * The value set may be {@code null}.
     */
    public BodyLines setUrl(String url) {
      this.url = url;
      return this;
    }

  }

  /**
   * Model definition for PromotionImage.
   */
  public static final class Image extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer height;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String source;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer width;

    /**

     * The value returned may be {@code null}.
     */
    public Integer getHeight() {
      return height;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setHeight(Integer height) {
      this.height = height;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getSource() {
      return source;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setSource(String source) {
      this.source = source;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public Integer getWidth() {
      return width;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setWidth(Integer width) {
      this.width = width;
      return this;
    }

  }

}
